# -*- coding: utf-8 -*-
from PyQt5 import *
from PyQt5 import QtGui
from PyQt5 import QtWidgets
import common
import dialogrdpui
import logging


class dialogRDPUI(QtWidgets.QDialog, dialogrdpui.Ui_DialogRDP):

    connectionname = ""

    def __init__(self, name, configfile):
        super(self.__class__, self).__init__()
        self.setupUi(self)
        self.connectionname = name
        # label
        common.setRessourceFile(configfile)
        self.setWindowTitle(common.getRessource("RDPViewerDialogTitle"))
        self.rdpOKButton.setText(common.getRessource("ButtonOK"))
        self.rdpCancelButton.setText(common.getRessource("ButtonCancel"))
        self.rdpLabelName.setText(common.getRessource("configDialogLabelName"))
        self.rdpLabelAddress.setText(
                                     common.getRessource("configDialogLabelAddress"))
        self.rdpLabelPort.setText(
                                     common.getRessource("configDialogLabelPort"))
        self.rdpLabelLogin.setText(
                                     common.getRessource("configDialogLabelLogin"))
        self.rdpLabelPassword.setText(
                                     common.getRessource("configDialogLabelPassword"))
        self.rdpLabelDomain.setText(
                                     common.getRessource("configDialogLabelDomain"))
        self.rdpLabelDrive.setText(
                                     common.getRessource("configDialogLabelDrive"))
        self.rdpLabelResolution.setText(
                                        common.getRessource("configDialogLabelResolution"))
        self.rdpLabelColor.setText(
                                   common.getRessource("configDialogLabelColor"))
        self.rdpLabelPrinter.setText(
                                   common.getRessource("configDialogLabelPrinter"))
        self.rdpLabelParameter.setText(
                                       common.getRessource("configDialogLabelParameter"))
        self.rdpInputAutostart.setText(
                                       common.getRessource("configDialogLabelAutostart"))
        self.rdpInputRepeat.setText(
                                    common.getRessource("configDialogLabelRepeat"))
        self.rdpInputSystemLogin.setText(
                                         common.getRessource("configDialogLabelSystemLogin"))
        self.rdpLabelAlternative.setText(
                                         common.getRessource("configDialogLabelAlternative"))    
        self.rdpInputIcon.setText(
                                         common.getRessource("configDialogLabelIcon"))
        self.rdpLabelIconName.setText(
                                         common.getRessource("configDialogLabelIconName"))
        self.rdpInputHostalive.setText(common.getRessource("configDialogInputHostalive"))
        self.rdpLabelUSB.setText(common.getRessource("configDialogLabelUSB"))
        self.rdpInputCertignore.setText(common.getRessource("configDialogLabelCertignore"))
        self.rdpInputGlyphcache.setText(common.getRessource("configDialogLabelGlyphcache"))
        self.rdpInputClipboard.setText(common.getRessource("configDialogLabelClipboard"))
        self.rdpLabelGDI.setText(common.getRessource("configDialogLabelGDI"))
        self.rdpInputGFX.setText(common.getRessource("configDialogLabelGFX"))
        self.rdpInputRFX.setText(common.getRessource("configDialogLabelRFX"))
        self.rdpInputXfreerdp2.setText(common.getRessource("configDialogLabelXfreerdp2"))
        self.rdpInputXfreerdp3.setText(common.getRessource("configDialogLabelXfreerdp3"))
        
        #action
        self.rdpOKButton.clicked.connect(self.ButtonOK)
        self.rdpCancelButton.clicked.connect(self.ButtonCancel)
        # fill ComboBox
        common.fillComboBox(self, "RDPViewerResolutions",
                            self.rdpInputResolution)
        common.fillComboBox(self, "RDPViewerColorLevel", self.rdpInputColor)
        common.fillComboBoxConnections(self, self.rdpInputAlternative)
        common.fillComboBox(self, "RDPViewerGDIParam", self.rdpInputGDI)
        self.rdpInputHostalive.setChecked(True)
        printer = common.getPrinter()
        common.fillComboBoxList(self, printer, self.rdpInputPrinter)
        usb = common.getUSBDevice()
        common.fillComboBoxList(self, usb, self.rdpInputUSB)
        drive = common.getUSBDrive()
        common.fillComboBoxList(self, drive, self.rdpInputDrive)
        
        if self.connectionname == "":
            index = self.rdpInputGDI.findText("hw", QtCore.Qt.MatchFixedString)
            if index >= 0:
                self.rdpInputGDI.setCurrentIndex(index)
            self.rdpInputCertignore.setChecked(True)
            self.rdpInputGlyphcache.setChecked(True)
            self.rdpInputXfreerdp2.setChecked(True)
        else:
            # read connection parameter and fill dialog
            connection = common.readConnection(self.connectionname)
            self.rdpInputName.setText(self.connectionname)
            self.rdpInputAddress.setText(connection["address"])
            if "port" in connection:
                self.rdpInputPort.setText(connection["port"])
            if "login" in connection:
                self.rdpInputLogin.setText(connection["login"])
            if "password" in connection:
                self.rdpInputPassword.setText(connection["password"])
            if "domain" in connection:
                self.rdpInputDomain.setText(connection["domain"])
            self.rdpInputParameter.setText(connection["parameter"])
            # Resolution
            index = self.rdpInputResolution.findText(connection["resolution"],
                                                     QtCore.Qt.MatchFixedString)
            if index >= 0:
                self.rdpInputResolution.setCurrentIndex(index)
            # Color
            index = self.rdpInputColor.findText(connection["color"],
                                                QtCore.Qt.MatchFixedString)
            if index >= 0:
                self.rdpInputColor.setCurrentIndex(index)
            # Autostart
            autostart = connection["autostart"]
            if autostart == "yes":
                self.rdpInputAutostart.setChecked(True)
            # Repeat
            repeat = connection["repeat"]
            if repeat == "yes":
                self.rdpInputRepeat.setChecked(True)
            # Own Login
            systemlogin = connection["systemlogin"]
            if systemlogin == "yes":
                self.rdpInputSystemLogin.setChecked(True)
            # host alive
            self.rdpInputHostalive.setChecked(False)
            hostalive = connection["hostalive"]
            if hostalive == "yes":
                self.rdpInputHostalive.setChecked(True)
            # Printer
            printer = connection["printer"]
            index = self.rdpInputPrinter.findText(printer, QtCore.Qt.MatchFixedString)
            self.rdpInputPrinter.setCurrentIndex(index)
            # USB
            usb = connection["usb"]
            index = self.rdpInputUSB.findText(usb, QtCore.Qt.MatchFixedString)
            if index == -1:
                self.rdpInputUSB.addItem(usb)
                index = self.rdpInputUSB.findText(usb, QtCore.Qt.MatchFixedString)
            self.rdpInputUSB.setCurrentIndex(index)
            # USB Drive
            if "drive" in connection:
                drive = connection["drive"]
                index = self.rdpInputDrive.findText(drive, QtCore.Qt.MatchFixedString)
                if index == -1:
                    self.rdpInputDrive.addItem(drive)
                    index = self.rdpInputDrive.findText(drive, QtCore.Qt.MatchFixedString)
                self.rdpInputDrive.setCurrentIndex(index)
            
            # Cert ignore
            certignore = connection["certignore"]
            if certignore == "yes":
                self.rdpInputCertignore.setChecked(True)
            # GDI
            gdi = connection["gdi"]
            index = self.rdpInputGDI.findText(gdi, QtCore.Qt.MatchFixedString)
            if index >= 0:
                self.rdpInputGDI.setCurrentIndex(index)
            # GFX
            gfx = connection["gfx"]
            if gfx == "yes":
                self.rdpInputGFX.setChecked(True)
            # RFX
            rfx = connection["rfx"]
            if rfx == "yes":
                self.rdpInputRFX.setChecked(True)
            # Glyph cache
            glyphcache = connection["glyphcache"]
            if glyphcache == "yes":
                self.rdpInputGlyphcache.setChecked(True)
            # Clipboard
            clipboard = connection["clipboard"]
            if clipboard == "yes":
                self.rdpInputClipboard.setChecked(True)
            # Alternative
            alternative = connection["alternative"]
            if alternative != "":
                index = self.rdpInputAlternative.findText(alternative, QtCore.Qt.MatchFixedString)
                self.rdpInputAlternative.setCurrentIndex(index)    
            # Icon
            icon = "no"
            if "icon" in connection:
                icon = connection["icon"]
            if icon == "yes":
                self.rdpInputIcon.setChecked(True)
            iconname = ""
            if "iconname" in connection:
                iconname = connection["iconname"]
            self.rdpInputIconName.setText(iconname)
            # xfreerdp version 3
            self.rdpInputXfreerdp2.setChecked(True)
            if "xfreerdp3" in connection:
                if connection["xfreerdp3"] == "yes":
                    self.rdpInputXfreerdp3.setChecked(True)
                    self.rdpInputXfreerdp2.setChecked(False)
                
    def ButtonOK(self):
        logging.info("ButtonOK")
        error = False
        if self.rdpInputName.text() == "":
            common.messageDialog("configDialogErrorName")
            error = True
        elif " " in self.rdpInputName.text():
            common.messageDialog("configDialogErrorCharacter")
            error = True
        elif "[" in self.rdpInputName.text():
            common.messageDialog("configDialogErrorCharacter")
            error = True
        elif "]" in self.rdpInputName.text():
            common.messageDialog("configDialogErrorCharacter")
            error = True
        elif self.rdpInputAddress.text() == "":
            common.messageDialog("configDialogErrorAddress")
            error = True
        elif common.isNetworkAddress(self.rdpInputAddress.text()) is False:
            error = True
        elif self.rdpInputIcon.isChecked() and self.rdpInputIconName.text() == "":
            common.messageDialog("configDialogErrorIconName")
            error = True

        name = self.rdpInputName.text()
        if common.existingConnection(name):
            common.messageDialog("configDialogErrorAddress")
            error = True

        if error is False:
            values = {}
            values["typ"] = "rdp"
            values["address"] = self.rdpInputAddress.text()
            values["port"] = self.rdpInputPort.text()
            values["login"] = self.rdpInputLogin.text()
            values["password"] = self.rdpInputPassword.text()
            values["domain"] = self.rdpInputDomain.text()
            values["resolution"] = self.rdpInputResolution.currentText()
            values["color"] = self.rdpInputColor.currentText()
            values["printer"] = self.rdpInputPrinter.currentText()
            values["gdi"] = self.rdpInputGDI.currentText()
            values["usb"] = self.rdpInputUSB.currentText()
            values["drive"] = self.rdpInputDrive.currentText()
            values["parameter"] = self.rdpInputParameter.text()
            if self.rdpInputAutostart.isChecked():
                values["autostart"] = "yes"
            else:
                values["autostart"] = "no"
            if self.rdpInputRepeat.isChecked():
                values["repeat"] = "yes"
            else:
                values["repeat"] = "no"
            if self.rdpInputSystemLogin.isChecked():
                values["systemlogin"] = "yes"
            else:
                values["systemlogin"] = "no"

            if self.rdpInputHostalive.isChecked():
                values["hostalive"] = "yes"
            else:
                values["hostalive"] = "no"

            if self.rdpInputCertignore.isChecked():
                values["certignore"] = "yes"
            else:
                values["certignore"] = "no"
            if self.rdpInputGlyphcache.isChecked():
                values["glyphcache"] = "yes"
            else:
                values["glyphcache"] = "no"
                
            if self.rdpInputClipboard.isChecked():
                values["clipboard"] = "yes"
            else:
                values["clipboard"] = "no"
                
            if self.rdpInputGFX.isChecked():
                values["gfx"] = "yes"
            else:
                values["gfx"] = "no"
                
            if self.rdpInputRFX.isChecked():
                values["rfx"] = "yes"
            else:
                values["rfx"] = "no"
                
            values["alternative"] = str(self.rdpInputAlternative.currentText())
            
            if self.rdpInputIcon.isChecked():
                values["icon"] = "yes"
            else:
                values["icon"] = "no"
            
            values["iconname"] = str(self.rdpInputIconName.text())
            if self.rdpInputXfreerdp3.isChecked():
                values["xfreerdp3"] = "yes"
            else:
                values["xfreerdp3"] = "no"
                
            # delete old connection
            if self.connectionname != "":
                common.deleteConnection(self.connectionname)
            # delete new connection
            common.deleteConnection(self.rdpInputName.text())
            # make new connection
            parameter = self.parameterRDP(self.rdpInputName.text(), values)
            common.newConnection(values, parameter, self.rdpInputName.text())
            self.close()

    def ButtonCancel(self):
        logging.info("ButtonCancel")
        self.close()

    def parameterRDP(self, connectionname, values):
        logging.info("parameterRDP")
        parameters = common.getRessource("commandRDPViewer")
        xfreerdp3 = False
        if values["xfreerdp3"] == "yes":
            parameters = common.getRessource("commandRDPViewer3")
            xfreerdp3 = True
        parameters = parameters + " " + common.getRessource("RDPViewerServer") + values["address"]
        if values["port"] != "":
            parameters = parameters + " " + common.getRessource("RDPViewerPort") + values["port"]
        if values["resolution"] == "FullScreen":
            parameters = parameters + " " + common.getRessource("RDPViewerFullScreen")
        else:
            parameters = parameters + " " + common.getRessource("RDPViewerScreen") + values["resolution"]
        parameters = parameters + " " + common.getRessource("RDPViewerColor") + values["color"]
        
        if values["systemlogin"] == "yes":
            parameters = parameters + " " + common.getRessource("RDPViewerUser") + common.getRessource("commandPlaceholderUser")
            parameters = parameters + " " + common.getRessource("RDPViewerPassword") + common.getRessource("commandPlaceholderPassword")
        else:
            if values["login"] != "":
                parameters = parameters + " " + common.getRessource("RDPViewerUser") + common.getRessource("commandPlaceholderUser")
            if values["password"] != "":
                parameters = parameters + " " + common.getRessource("RDPViewerPassword") + common.getRessource("commandPlaceholderPassword")

        if values["domain"] != "":
            parameters = parameters + " " + common.getRessource("RDPViewerDomain") + values["domain"]
            
        if values["printer"] != "":
            parameters = parameters + " " + common.getRessource("RDPViewerPrinter") + values["printer"]

        if values["usb"] != "":
            usb = common.getUSBDeviceParam(values["usb"])
            parameters = parameters + " " + common.getRessource("RDPViewerUSB") + usb
        
        if values["drive"] != "":
            parameters = parameters + " " + common.getRessource("RDPViewerDrive") + values["drive"]
            
        if values["gdi"] != "":
            parameters = parameters + " " + common.getRessource("RDPViewerGDI") + values["gdi"]

        if values["gfx"] == "yes":
            if xfreerdp3:
                parameters = parameters + " " + common.getRessource("RDPViewerGFX3")
            else:
                parameters = parameters + " " + common.getRessource("RDPViewerGFX2")
            
        if values["rfx"] == "yes":
            if xfreerdp3:
                parameters = parameters + " " + common.getRessource("RDPViewerRFX3")
            else:
                parameters = parameters + " " + common.getRessource("RDPViewerRFX2")

        if values["glyphcache"] == "yes":
            if xfreerdp3:
                parameters = parameters + " " + common.getRessource("RDPViewerGlyphcache3")
            else:
                parameters = parameters + " " + common.getRessource("RDPViewerGlyphcache2")
                
        if values["clipboard"] == "no":
            if xfreerdp3:
                parameters = parameters + " " + common.getRessource("RDPViewerClipboard3")
            else:
                parameters = parameters + " " + common.getRessource("RDPViewerClipboard2")
                
        if values["certignore"] == "yes":
            if xfreerdp3:
                parameters = parameters + " " + common.getRessource("RDPViewerCertignore3")
            else:
                parameters = parameters + " " + common.getRessource("RDPViewerCertignore2")

        if values["parameter"] != "":
            parameters = parameters + " " + values["parameter"]
        return parameters

