from PyQt5 import QtCore
from PyQt5 import QtGui
from PyQt5 import QtWidgets
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *
import common
import connectThread
import dialogvpn
import configurationdialog
import logging
import os
import shutil

def autostartvpn(self, vpnsystem, vpnfile, parameter, systemlogin, runfile, otp):
    logging.info("autostartvpn")
    vpnExec(self, vpnsystem, vpnfile, parameter, systemlogin, runfile, otp)

        
def vpnExec(self, vpnsystem, vpnfile, parameter, systemlogin, runfile, otp):
    logging.info("vpnExec")
    logging.info("vpnsystem " + vpnsystem)
    logging.info("vpnfile " + vpnfile)
    logging.info("parameter " + str(parameter))
    logging.info("systemlogin " + systemlogin)
    logging.info("runfile " + runfile)
    logging.info("otp " + otp)
    global Vpnsystem
    Vpnsystem = vpnsystem 
    if runfile != "":
        command = "sudo " + runfile
        command = command + " -f '" + vpnfile + "'"
    else:
        if vpnsystem == "ovpn":
            command = common.getRessource("commandVPNOvpnExec")
            command = command + " -f '" + vpnfile + "'"
        else:
            command = common.getRessource("commandVPNWireguardExec")
    command = command + " -o " + common.getRessource("commandVPNLog")
    if parameter != None:
        command = command + " -e \"" + parameter  + "\""
    result = True
    if systemlogin == "yes" and vpnsystem == "ovpn":
        needinput = True
        while needinput:
            dialogLogin = dialogvpn.dialogVPNUI(self.configfile, "VPN", otp)
            dialogLogin.exec_()
            result = dialogLogin.getResult()
            if result is True:
                if dialogLogin.getLogin() != "" and dialogLogin.getPassword() != "":
                    loginUser = dialogLogin.getLogin()
                    loginPassword = dialogLogin.getPassword()
                    loginOTP = dialogLogin.getOTP()
                    command = command + " -u '" + loginUser + "'"
                    command = command + " -p '" + loginPassword + "'"
                    if runfile != "" and loginOTP != "":
                        command = command + " -t " + loginOTP
                    needinput = False
            else:
                break
    logging.info(command)
    
    if result:
        # run connection as thread
        connectionlog = common.getRessource("fileConnectionLog")
        runconnect = connectThread.connectThread(command, "vpn", connectionlog)
        runconnect.threadCancel.connect(self.connectThreadCancel)
        # close Dialog after thread end
        runconnect.finished.connect(connectionEstablished)
        self.connectedThreads["vpn"] = runconnect
        global VpnButtonConnect
        VpnButtonConnect = self.vpnButtonConnect
        global VpnButtonCondition
        VpnButtonCondition = self.vpnButtonCondition
        runconnect.start()
        # show message dialog during configuration
        global DialogConfiguration
        DialogConfiguration = configurationdialog.dialogConfigurationUI(self.configfile, common.getRessource("vpnConnectMessage"))
        DialogConfiguration.exec_()


# close dialog and read vpn state
def connectionEstablished():
    DialogConfiguration.close()
    if Vpnsystem == "ovpn":
        command = common.getRessource("commandVPNOvpnState")
    else:
        command = common.getRessource("commandVPNWireguardState")
    command = command + " " + common.getRessource("commandVPNLog")
    logging.info(command)
    result =  common.runProgram(command)
    if result:
        VpnButtonConnect.setEnabled(False)
        VpnButtonCondition.setIcon(QtGui.QIcon(common.getRessource("connectIcon")))
    
    
# Button Transfer
def vpnTransfer(self):
    logging.info("vpnTransfer")
    values = {}
    if self.vpnInputOvpn.isChecked():
        values["program"] = "ovpn"
    if self.vpnInputWireguard.isChecked():
        values["program"] = "wireguard"
    values["configfile"] = self.vpnInputFile.text()
    values["parametervpn"] = self.vpnInputParameter.text()
    values["runfile"] = self.vpnInputRunfile.text()
    values["autostartvpn"] = "no" 
    if self.vpnInputAutostart.isChecked():
        values["autostartvpn"] = "yes"
    values["systemlogin"] = "no" 
    if self.vpnInputSystemLogin.isChecked():
        values["systemlogin"] = "yes"
    values["otp"] = "no" 
    if self.vpnInputOTP.isChecked():
        values["otp"] = "yes"
    writeVPN(values)
    
    
# Button Connect
def vpnConnect(self):
    logging.info("vpnConnect")
    vpnfile = self.vpnInputFile.text()
    parameter = self.vpnInputParameter.text()
    runfile = self.vpnInputRunfile.text()
    systemlogin = "no"
    if self.vpnInputSystemLogin.isChecked():
        systemlogin = "yes"
    otp = "no"
    if self.vpnInputOTP.isChecked():
        otp = "yes"
    if self.vpnInputOvpn.isChecked():
        vpnsystem = "ovpn"
    else:
        vpnsystem = "wireguard"
    vpnExec(self, vpnsystem, vpnfile, parameter, systemlogin, runfile, otp)
    
        
# Button Cancel
def vpnCancel(self):
    logging.info("vpnCancel")
    if self.vpnInputOvpn.isChecked():
        command = common.getRessource("commandVPNOvpnKill") 
    else:
        command = common.getRessource("commandVPNWireguardKill") 
    command = command + " " + common.getRessource("commandVPNLog") 
    logging.info(command)
    common.runProgram(command)
    self.vpnButtonConnect.setEnabled(True)
    self.vpnButtonCondition.setIcon(QtGui.QIcon(common.getRessource("disconnectIcon")))
    
        
# Button Condition
def vpnCondition(self):
    logging.info("vpnCondition")
       
    try:
        fileout = common.getRessource("commandVPNLog")
        filer = open(fileout, "r")
        text = filer.read()
        filer.close()
        common.textDialog("VPN", text)
    except OSError as error:
        pass        
    

def vpnGetFile(self):
    logging.info("vpnGetFile")
    command = common.getRessource("commandMountUSB") 
    logging.info(command)
    common.runProgram(command, False)
    filename = getFile("file", common.getRessource("VPNUSBDirectory"))
    if filename != "":
        if self.vpnInputOvpn.isChecked():
            targetfilename = common.getRessource("VPNOvpnFile")
        else:
            targetfilename = common.getRessource("VPNWireguardFile")
        command = common.getRessource("commandVPNCopy") + " " + filename + " " + targetfilename
        logging.info(command)
        common.runProgram(command)
        self.vpnInputFile.setText(targetfilename)
    command = common.getRessource("commandUmountUSB") 
    logging.info(command)
    common.runProgram(command, False)
   
def vpnRunFile(self):
    logging.info("vpnRunFile")
    command = common.getRessource("commandMountUSB")
    logging.info(command)
    common.runProgram(command, False)
    filename = getFile("file", common.getRessource("VPNUSBDirectory"))
    if filename != "":
        targetfilename = common.getRessource("VPNRunfile")
        command = common.getRessource("commandVPNCopy") + " " + filename + " " + targetfilename
        logging.info(command)
        common.runProgram(command)
        command = common.getRessource("commandVPNChmod") + " " + targetfilename
        logging.info(command)
        common.runProgram(command)
        self.vpnInputRunfile.setText(targetfilename)
    command = common.getRessource("commandUmountUSB") 
    logging.info(command)
    common.runProgram(command, False)
         
def vpnAdditionalFiles(self):
    logging.info("vpnAdditionalFiles")
    command = common.getRessource("commandMountUSB") 
    logging.info(command)
    common.runProgram(command, False)
    filename = getFile(None, common.getRessource("VPNUSBDirectory"))
    if filename != "":
        command = common.getRessource("commandVPNCopy") + " " + filename
        logging.info(command)
        common.runProgram(command, False)
    command = common.getRessource("commandUmountUSB") 
    logging.info(command)
    common.runProgram(command, False)


def vpnDeleteFile(self):
    logging.info("vpnDeleteFile")
    directory = common.getRessource("VPNDirectory")
    filename = getFile(None, directory)
    if filename != "":
        if filename.startswith(directory):
            logging.info("delete " + filename)
            try:
                if os.path.isfile(filename):
                    os.remove(filename)
                    # if file is deleted, remove it from dialog
                    vpnfilename = self.vpnInputFile.text()
                    if filename == vpnfilename:
                        self.vpnInputFile.setText("")
                    
            except OSError as error:
                logging.error(error)
                common.errorDialog(error)
        else:
            logging.info("no delete " + filename)
            common.errorDialog(common.getRessource("systemErrorDeleteFile"))
    
    
def readVPN(self):
    logging.info("readVPN")
    values = {}
    vpnfile = common.getRessource("VPNFile")
    if os.path.isfile(vpnfile):
        try:
            filer = open(vpnfile, "r")
            for line in filer:
                line = line.strip()
                name = line.split("=", 2)
                values[name[0]] = name[1]
            filer.close()
        except IOError as error:
            logging.error(error)
            common.errorDialog(error)
    return values


def writeVPN(values):
    logging.info("writeVPN")
    try:
        tmpfile = common.getRessource("tmpFile")
        filew = open(tmpfile, "w")
        line = "program=" + values["program"] + "\n"
        filew.write(line)
        if values["configfile"] != "":
            line = "configfile=" + values["configfile"] + "\n"
            filew.write(line)
        if values["parametervpn"] != "":
            line = "parametervpn=" + values["parametervpn"] + "\n"
            filew.write(line)
        if values["runfile"] != "":
            line = "runfile=" + values["runfile"] + "\n"
            filew.write(line)        
        line = "autostartvpn=" + values["autostartvpn"] + "\n"
        filew.write(line)
        line = "systemlogin=" + values["systemlogin"] + "\n"
        filew.write(line)
        line = "otp=" + values["otp"] + "\n"
        filew.write(line)
        filew.close()
    except OSError as error:
        logging.error(error)
        common.errorDialog(error)
    try:
        # write file to system
        command = common.getRessource("commandVPNFile")
        command = command + " " + tmpfile
        common.runProgram(command)
    except OSError as error:
        logging.error(error)
        common.errorDialog(error)
        
        
def getFile(parameter, directory):
    dialog = QtWidgets.QFileDialog()
    dialog.setFileMode(QtWidgets.QFileDialog.AnyFile)    
    #if parameter == "file":
    #    dialog.setNameFilters(["files (*.ovpn)"])
    dialog.setDirectory(directory)
    filename = ""
    if dialog.exec_():
        filenames = dialog.selectedFiles()
        filename = filenames[0]
    return filename

