#!/bin/bash
# -f = ovpn file
# -o = output
# -u = user
# -p = password
# -t = one-time password
# -e = parameter

help=0

while getopts f:o:u:p:t:e:h opt
do 
  case $opt in
    f) ovpn=$OPTARG
       ;;
    o) output=$OPTARG
       ;;
    u) user=$OPTARG
       ;;
    p) password=$OPTARG
       ;;
    t) otp=$OPTARG
       ;;
    e) param=$OPTARG
       ;;
    h) help=1
       ;;   
  esac
done
  
if [ "help" == "1" ]
then
  echo "Parameters:"
  echo "-f <ovpn file>"
  echo "-o <output file>"
  echo "-u <user>"
  echo "-p <password>"
  echo "-t <one-time password>"
  echo "-e <parameter>"
  exit 1
fi

if [ "$ovpn" == "" ]
then
  echo "parameter -f <ovpn file> required"
  exit 1
fi
  
passfile=""
if [ "$user" != "" ]
then
  passfile=/tmp/openvpn.user
  echo $user > $passfile
  echo $password >> $passfile
  passfile="--auth-user-pass "$passfile
fi

if [ "$output" != "" ]
then
  output=" --log "$output
fi

cd /data/user/vpn
openvpn --config $ovpn $param $passfile $output &
exit 0

#!/usr/bin/expect -f
set totp [lindex $argv 0]
spawn openvpn --config /root/client.ovpn --auth-user-pass /root/pass.txt 
expect "CHALLENGE: TOTP"
send "$totp\r"
interact
